; 

    include \masm32\include\masm32rt.inc
    .686p
    .MMX
    .XMM

; 

    include dialog.inc

    .data?
      hInstance  dd ?
      hWnd       dd ?
      hButn1     dd ?
      hButn2     dd ?
      hButn3     dd ?
      hButn4     dd ?
      hButn5     dd ?
      hBitmap    dd ?
      hImage     dd ?
      hStatic    dd ?

    .code

start:
    mov hInstance, FUNC(GetModuleHandle, NULL)

  ; -------------------------------------------
  ; Call the dialog box from the resource file
  ; -------------------------------------------
    invoke DialogBoxParam,hInstance,100,0,ADDR DlgProc,0

    invoke ExitProcess,eax

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    ;; LOCAL wc:WNDCLASSEX
    LOCAL icce:INITCOMMONCONTROLSEX

      switch uMsg
        case WM_INITDIALOG

          mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX            ; set the structure size
          xor eax, eax                                            ; set EAX to zero
          or eax, ICC_WIN95_CLASSES
          mov icce.dwICC, eax
          invoke InitCommonControlsEx,ADDR icce                   ; initialise the common control library

          m2m hWnd, hWin    ; Copy hWin to GLOBAL variable
          invoke SendMessage,hWin,WM_SETICON,1,FUNC(LoadIcon,hInstance,500)

        ; --------------------------------
        ; Get the handle for each control
        ; --------------------------------
          mov hButn1, rv(GetDlgItem,hWin,101)
          mov hButn2, rv(GetDlgItem,hWin,102)
          mov hButn3, rv(GetDlgItem,hWin,103)
          mov hButn4, rv(GetDlgItem,hWin,104)
          mov hButn5, rv(GetDlgItem,hWin,105)
          mov hImage, rv(GetDlgItem,hWin,200)
          mov hStatic, rv(GetDlgItem,hWin,201)

          invoke LoadImage,hInstance,150,IMAGE_BITMAP,0,0, \
                 LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS
          mov hBitmap, eax

          fn SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hBitmap

          .data
            txtmsg db "Do you need a new car ?",0
          .code

          invoke SetWindowText,hStatic,ADDR txtmsg

          xor eax, eax
          ret

      case WM_COMMAND
        switch wParam
          case 101
            fn MsgboxI,hWnd,"Yes Button    ","Howdy",MB_OK,500
          case 102
            fn MsgboxI,hWnd,"No Button    ","Howdy",MB_OK,500
          case 103
            fn MsgboxI,hWnd,"Don't Know Button    ","Howdy",MB_OK,500
          case 104
            fn MsgboxI,hWnd,"Who Cares Button    ","Howdy",MB_OK,500
          case 105
            jmp exit_dialog
        endsw

      case WM_CLOSE
        exit_dialog:                ; jump to this label to close program
        invoke EndDialog,hWin,0

      endsw

    xor eax, eax    ; this must be here in NT4 and later
    ret

DlgProc endp

; 

MsgboxI proc hParent:DWORD,pText:DWORD,pTitle:DWORD,mbStyle:DWORD,IconID:DWORD

    LOCAL mbp   :MSGBOXPARAMS

    or mbStyle, MB_USERICON

    mov mbp.cbSize,             SIZEOF mbp
    m2m mbp.hwndOwner,          hParent
    mov mbp.hInstance,          rv(GetModuleHandle,0)
    m2m mbp.lpszText,           pText
    m2m mbp.lpszCaption,        pTitle
    m2m mbp.dwStyle,            mbStyle
    m2m mbp.lpszIcon,           IconID
    mov mbp.dwContextHelpId,    NULL
    mov mbp.lpfnMsgBoxCallback, NULL
    mov mbp.dwLanguageId,       NULL

    invoke MessageBoxIndirect,ADDR mbp

    ret

MsgboxI endp

; 

end start

